PROGRAM prgMain
  VAR CONSTANT
    IP_Address      : STRING := '192.168.1.125:502';
    chanCode        : UINT   := ETH1_uni0;
    tcp             : BOOL   := true;
    INVERTER_COUNT  : USINT  := 4;      (* maximalni pocet zarizeni typu Inverter *)
    STRINGBOX_COUNT : USINT  := 4;      (* maximalni pocet zarizeni typu StringBox*)
    BATTERY_COUNT   : USINT  := 2;      (* maximalni pocet zarizeni typu Battery*)
    METER_COUNT     : USINT  := 3;      (* maximalni pocet zarizeni typu Meter*)
    DEVICE_COUNT    : USINT  := INVERTER_COUNT + STRINGBOX_COUNT + BATTERY_COUNT + METER_COUNT;
    PERIOD_TIME     : TIME   := T#10s;
  END_VAR

  VAR_INPUT
  END_VAR
  VAR_OUTPUT
  END_VAR
  VAR
    smInit : fb_SMInit;
    smInit_enable : BOOL := true;
    sm : fb_SMReadData;
    DeviceInfo : ARRAY [1..DEVICE_COUNT]    OF TDeviceBlockInfo; (*Informace o blocich v jednotlivych zarizenich*)
    Inverter   : ARRAY [1..INVERTER_COUNT]  OF TInverter;
    StringBox  : ARRAY [1..STRINGBOX_COUNT] OF TStringBox;
    Battery    : ARRAY [1..BATTERY_COUNT]   OF TBattery;
    Meter      : ARRAY [1..METER_COUNT]     OF TMeter;
    DeviceTypeCount : TDeviceTypeCount;
    smMiB : fb_SMReadStuderMiBData;
    DeviceMiB : ARRAY [1..DEVICE_COUNT] OF TDeviceMiB; (*Rozsirene promenne (specificke, detailnejsi)*)
    read_SR : SR;
    MiB_SR : SR;
   // init_done : BOOL;
   // read_ready : BOOL;
    timer : TON;
    pass_done : BOOL;
   // timer_done : BOOL;
    timer_SR : SR;
    timer_ET : TIME;
  END_VAR
  VAR_TEMP
  END_VAR
{NOCODE}
<?xml version="1.0" encoding="windows-1250" ?>
<?xml-stylesheet type="text/xsl" href="pokus.xsl" version="1.1"?>
<fbd version="1.1">
<comment id="1" height="3" width="12">
  <position x="3" y="5" />
Schema comment
</comment>
<block name="fb_SMReadData" instance="sm" id="2" height="14" width="14" line="30" order="8">
  <position x="110" y="12" />
  <inVariables>
    <variable name="enable" type="BOOL">
      <connection refid="8" name="Q1">
        <position x="110" y="15" />
        <position x="109" y="15" />
        <position x="109" y="15" />
        <position x="94" y="15" />
      </connection>
    <comment>if enable=0, block is disabled, start with rising edge</comment>
    </variable>
    <variable name="ip" type="STRING[80]">
      <connection refid="38">
        <position x="110" y="17" />
        <position x="107" y="17" />
        <position x="107" y="6" />
        <position x="107" y="6" />
      </connection>
    <comment>SM2-MU gateway IP address</comment>
    </variable>
    <variable name="chanCode" type="UINT">
      <connection refid="39">
        <position x="110" y="19" />
        <position x="105" y="19" />
        <position x="105" y="7" />
        <position x="105" y="7" />
      </connection>
    <comment>communication channel number</comment>
    </variable>
    <variable name="tcp" type="BOOL">
      <connection refid="40">
        <position x="110" y="21" />
        <position x="103" y="21" />
        <position x="103" y="8" />
        <position x="103" y="8" />
      </connection>
    <comment>protocol type - TRUE = TCP, FALSE = UDP</comment>
    </variable>
    <variable name="DevInfoPtr" type="PTR_TO TDeviceBlockInfo">
      <connection refid="25">
        <position x="110" y="23" />
        <position x="109" y="23" />
        <position x="109" y="23" />
        <position x="105" y="23" />
      </connection>
    <comment>pointer to array of blocks obtained with fb_ReadDeviceInfo</comment>
    </variable>
    <variable name="devCount" type="USINT">
      <connection refid="34">
        <position x="110" y="25" />
        <position x="109" y="25" />
        <position x="109" y="25" />
        <position x="108" y="25" />
      </connection>
    <comment>number of detected devices</comment>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="done" type="BOOL">
    <comment>block finished</comment>
    </variable>
    <variable name="busy" type="BOOL">
    <comment>block is still running</comment>
    </variable>
    <variable name="err" type="BOOL">
    <comment>block ended with error</comment>
    </variable>
    <variable name="errCode" type="USINT">
    <comment>error code</comment>
    </variable>
    <variable name="errTxt" type="STRING[80]">
    <comment>error report</comment>
    </variable>
  </outVariables>
</block>
<block name="SR" instance="timer_SR" id="3" height="6" width="6" line="20" order="3">
  <position x="87" y="47" />
  <inVariables>
    <variable name="S1" type="BOOL">
      <connection refid="37">
        <position x="87" y="50" />
        <position x="81" y="50" />
        <position x="81" y="35" />
        <position x="86" y="35" />
      </connection>
    </variable>
    <variable name="R" type="BOOL">
      <connection refid="41">
        <position x="87" y="52" />
        <position x="86" y="52" />
        <position x="86" y="52" />
        <position x="84" y="52" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="Q1" type="BOOL">
    </variable>
  </outVariables>
</block>
<block name="TON" instance="timer" id="4" height="6" width="6" line="21" order="4">
  <position x="98" y="47" />
  <inVariables>
    <variable name="IN" type="BOOL">
      <connection refid="3" name="Q1">
        <position x="98" y="50" />
        <position x="94" y="50" />
        <position x="94" y="50" />
        <position x="93" y="50" />
      </connection>
    <comment>input</comment>
    </variable>
    <variable name="PT" type="TIME">
      <connection refid="6">
        <position x="98" y="52" />
        <position x="97" y="52" />
        <position x="97" y="57" />
        <position x="12" y="57" />
      </connection>
    <comment>preset</comment>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="Q" type="BOOL">
    <comment>output</comment>
    </variable>
    <variable name="ET" type="TIME">
    <comment>value</comment>
    </variable>
  </outVariables>
</block>
<outVariable name="timer_ET" type="TIME" id="5" order="5">
  <position x="107" y="58" />
  <connection refid="4" name="ET">
    <position x="108" y="59" />
    <position x="105" y="59" />
    <position x="105" y="52" />
    <position x="104" y="52" />
  </connection>
</outVariable>
<inVariable name="PERIOD_TIME" type="TIME" id="6">
  <position x="1" y="56" />
</inVariable>
<block name="OR" instance="" function="true" extensible="true" hiddenPins="true" operator="true" id="7" height="4" width="3" line="25" order="6">
  <position x="81" y="14" />
  <inVariables>
    <variable name="IN1" type="ANY_BIT">
      <connection refid="9" name="done">
        <position x="81" y="15" />
        <position x="80" y="15" />
        <position x="80" y="15" />
        <position x="61" y="15" />
      </connection>
    </variable>
    <variable name="IN2" type="ANY_BIT">
      <connection refid="41">
        <position x="81" y="17" />
        <position x="78" y="17" />
        <position x="78" y="52" />
        <position x="84" y="52" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="OR" type="ANY_BIT">
    <comment>Bitwise OR
	compares every bits on same position in IN1, IN2, ... and generates a 1 result
	if either or all bits are 1, otherwise it returns 0
</comment>
    </variable>
  </outVariables>
</block>
<block name="SR" instance="read_SR" id="8" height="6" width="6" line="27" order="7">
  <position x="88" y="12" />
  <inVariables>
    <variable name="S1" type="BOOL">
      <connection refid="7" name="OR">
        <position x="88" y="15" />
        <position x="86" y="15" />
        <position x="86" y="15" />
        <position x="84" y="15" />
      </connection>
    </variable>
    <variable name="R" type="BOOL">
      <connection refid="37">
        <position x="88" y="17" />
        <position x="86" y="17" />
        <position x="86" y="35" />
        <position x="86" y="35" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="Q1" type="BOOL">
    </variable>
  </outVariables>
</block>
<block name="fb_SMInit" instance="smInit" id="9" height="30" width="20" line="9" order="1">
  <position x="41" y="12" />
  <inVariables>
    <variable name="enable" type="BOOL">
      <connection refid="10">
        <position x="41" y="15" />
        <position x="18" y="15" />
        <position x="18" y="15" />
        <position x="12" y="15" />
      </connection>
    <comment>if enable=0, block is disabled, start with rising edge</comment>
    </variable>
    <variable name="ip" type="STRING[80]">
      <connection refid="26">
        <position x="41" y="17" />
        <position x="34" y="17" />
        <position x="34" y="17" />
        <position x="33" y="17" />
      </connection>
    <comment>SM2-MU gateway IP address</comment>
    </variable>
    <variable name="chanCode" type="UINT">
      <connection refid="28">
        <position x="41" y="19" />
        <position x="36" y="19" />
        <position x="36" y="19" />
        <position x="35" y="19" />
      </connection>
    <comment>communication channel number</comment>
    </variable>
    <variable name="tcp" type="BOOL">
      <connection refid="27">
        <position x="41" y="21" />
        <position x="38" y="21" />
        <position x="38" y="21" />
        <position x="37" y="21" />
      </connection>
    <comment>protocol type - TRUE = TCP, FALSE = UDP</comment>
    </variable>
    <variable name="DevInfoPtr" type="PTR_TO TDeviceBlockInfo">
      <connection refid="24">
        <position x="41" y="23" />
        <position x="21" y="23" />
        <position x="21" y="27" />
        <position x="14" y="27" />
      </connection>
    <comment>pointer to array start</comment>
    </variable>
    <variable name="DevInfoSize" type="USINT">
      <connection refid="14">
        <position x="41" y="25" />
        <position x="23" y="25" />
        <position x="23" y="30" />
        <position x="14" y="30" />
      </connection>
    <comment>max. number of devices (array size)</comment>
    </variable>
    <variable name="InverterPtr" type="PTR_TO TInverter">
      <connection refid="15">
        <position x="41" y="27" />
        <position x="25" y="27" />
        <position x="25" y="33" />
        <position x="12" y="33" />
      </connection>
    <comment>Pointer to array of Inverter structures</comment>
    </variable>
    <variable name="InverterCount" type="USINT">
      <connection refid="19">
        <position x="41" y="29" />
        <position x="27" y="29" />
        <position x="27" y="36" />
        <position x="15" y="36" />
      </connection>
    <comment>max. number of Inverters (array size)</comment>
    </variable>
    <variable name="StringBoxPtr" type="PTR_TO TStringBox">
      <connection refid="16">
        <position x="41" y="31" />
        <position x="29" y="31" />
        <position x="29" y="39" />
        <position x="13" y="39" />
      </connection>
    <comment>Pointer to array of StringBox structures</comment>
    </variable>
    <variable name="StringBoxCount" type="USINT">
      <connection refid="20">
        <position x="41" y="33" />
        <position x="31" y="33" />
        <position x="31" y="42" />
        <position x="17" y="42" />
      </connection>
    <comment>max. number of Inverters (array size)</comment>
    </variable>
    <variable name="BatteryPtr" type="PTR_TO TBattery">
      <connection refid="17">
        <position x="41" y="35" />
        <position x="33" y="35" />
        <position x="33" y="45" />
        <position x="12" y="45" />
      </connection>
    <comment>Pointer to array of Battery structures</comment>
    </variable>
    <variable name="BatteryCount" type="USINT">
      <connection refid="21">
        <position x="41" y="37" />
        <position x="35" y="37" />
        <position x="35" y="48" />
        <position x="15" y="48" />
      </connection>
    <comment>max. number of Batteries (array size)</comment>
    </variable>
    <variable name="MeterPtr" type="PTR_TO TMeter">
      <connection refid="18">
        <position x="41" y="39" />
        <position x="37" y="39" />
        <position x="37" y="51" />
        <position x="11" y="51" />
      </connection>
    <comment>Pointer to array of Meter structures</comment>
    </variable>
    <variable name="MeterCount" type="USINT">
      <connection refid="22">
        <position x="41" y="41" />
        <position x="39" y="41" />
        <position x="39" y="54" />
        <position x="13" y="54" />
      </connection>
    <comment>max. number of Meters (array size)</comment>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="done" type="BOOL">
    <comment>block finished</comment>
    </variable>
    <variable name="busy" type="BOOL">
    <comment>block is still running</comment>
    </variable>
    <variable name="err" type="BOOL">
    <comment>block ended with error</comment>
    </variable>
    <variable name="errCode" type="USINT">
    <comment>error code</comment>
    </variable>
    <variable name="errTxt" type="STRING[80]">
    <comment>error report</comment>
    </variable>
    <variable name="devCount" type="USINT">
    <comment>number of devices in the SM2-MU gateway</comment>
    </variable>
    <variable name="DevTypeCount" type="TDeviceTypeCount">
    <comment>structure with count of each device type</comment>
    </variable>
  </outVariables>
</block>
<inVariable name="smInit_enable" type="BOOL" id="10">
  <position x="1" y="14" />
</inVariable>
<inVariable name="IP_Address" type="STRING" id="11">
  <position x="1" y="17" />
</inVariable>
<inVariable name="chanCode" type="UINT" id="12">
  <position x="1" y="20" />
</inVariable>
<inVariable name="tcp" type="BOOL" id="13">
  <position x="1" y="23" />
</inVariable>
<inVariable name="DEVICE_COUNT" type="USINT" id="14">
  <position x="1" y="29" />
</inVariable>
<inVariable name="ADR(Inverter)" type="" id="15">
  <position x="0" y="32" />
</inVariable>
<inVariable name="ADR(StringBox)" type="" id="16">
  <position x="1" y="38" />
</inVariable>
<inVariable name="ADR(Battery)" type="" id="17">
  <position x="1" y="44" />
</inVariable>
<inVariable name="ADR(Meter)" type="" id="18">
  <position x="1" y="50" />
</inVariable>
<inVariable name="INVERTER_COUNT" type="USINT" id="19">
  <position x="1" y="35" />
  <comment>
 maximalni pocet zarizeni typu Inverter   </comment>
</inVariable>
<inVariable name="STRINGBOX_COUNT" type="USINT" id="20">
  <position x="1" y="41" />
  <comment>
 maximalni pocet zarizeni typu StringBox  </comment>
</inVariable>
<inVariable name="BATTERY_COUNT" type="USINT" id="21">
  <position x="1" y="47" />
  <comment>
 maximalni pocet zarizeni typu Battery  </comment>
</inVariable>
<inVariable name="METER_COUNT" type="USINT" id="22">
  <position x="1" y="53" />
  <comment>
 maximalni pocet zarizeni typu Meter  </comment>
</inVariable>
<outVariable name="DeviceTypeCount" type="TDeviceTypeCount" id="23" order="2">
  <position x="62" y="26" />
  <connection refid="9" name="DevTypeCount">
    <position x="63" y="27" />
    <position x="62" y="27" />
    <position x="62" y="27" />
    <position x="61" y="27" />
  </connection>
</outVariable>
<inVariable name="ADR(DeviceInfo)" type="" id="24">
  <position x="1" y="26" />
</inVariable>
<inVariable name="ADR(DeviceInfo)" type="" id="25">
  <position x="92" y="22" />
</inVariable>
<node id="26">
  <position x="33" y="17" />
  <connection refid="11">
    <position x="33" y="17" />
    <position x="17" y="17" />
    <position x="17" y="18" />
    <position x="10" y="18" />
  </connection>
</node>
<node id="27">
  <position x="37" y="21" />
  <connection refid="13">
    <position x="37" y="21" />
    <position x="19" y="21" />
    <position x="19" y="24" />
    <position x="5" y="24" />
  </connection>
</node>
<node id="28">
  <position x="35" y="19" />
  <connection refid="12">
    <position x="35" y="19" />
    <position x="17" y="19" />
    <position x="17" y="21" />
    <position x="9" y="21" />
  </connection>
</node>
<block name="SR" instance="MiB_SR" id="29" height="6" width="6" line="35" order="9">
  <position x="137" y="12" />
  <inVariables>
    <variable name="S1" type="BOOL">
      <connection refid="2" name="done">
        <position x="137" y="15" />
        <position x="131" y="15" />
        <position x="131" y="15" />
        <position x="124" y="15" />
      </connection>
    </variable>
    <variable name="R" type="BOOL">
      <connection refid="36">
        <position x="137" y="17" />
        <position x="129" y="17" />
        <position x="129" y="35" />
        <position x="129" y="35" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="Q1" type="BOOL">
    </variable>
  </outVariables>
</block>
<block name="fb_SMReadStuderMiBData" instance="smMiB" id="30" height="16" width="22" line="36" order="10">
  <position x="151" y="12" />
  <inVariables>
    <variable name="enable" type="BOOL">
      <connection refid="29" name="Q1">
        <position x="151" y="15" />
        <position x="145" y="15" />
        <position x="145" y="15" />
        <position x="143" y="15" />
      </connection>
    <comment>if enable=0, block is disabled, start with rising edge</comment>
    </variable>
    <variable name="ip" type="STRING[80]">
      <connection refid="38">
        <position x="151" y="17" />
        <position x="149" y="17" />
        <position x="149" y="6" />
        <position x="107" y="6" />
      </connection>
    <comment>SM2-MU gateway IP address</comment>
    </variable>
    <variable name="chanCode" type="UINT">
      <connection refid="39">
        <position x="151" y="19" />
        <position x="147" y="19" />
        <position x="147" y="7" />
        <position x="105" y="7" />
      </connection>
    <comment>communication channel number</comment>
    </variable>
    <variable name="tcp" type="BOOL">
      <connection refid="40">
        <position x="151" y="21" />
        <position x="145" y="21" />
        <position x="145" y="8" />
        <position x="103" y="8" />
      </connection>
    <comment>protocol type - TRUE = TCP, FALSE = UDP</comment>
    </variable>
    <variable name="DevInfoPtr" type="PTR_TO TDeviceBlockInfo">
      <connection refid="31">
        <position x="151" y="23" />
        <position x="150" y="23" />
        <position x="150" y="23" />
        <position x="144" y="23" />
      </connection>
    <comment>pointer to array of blocks obtained with fb_ReadDeviceInfo</comment>
    </variable>
    <variable name="DevMiBPtr" type="PTR_TO TDeviceMiB">
      <connection refid="33">
        <position x="151" y="25" />
        <position x="149" y="25" />
        <position x="149" y="26" />
        <position x="143" y="26" />
      </connection>
    <comment>pointer to array of devices which this fb will fill</comment>
    </variable>
    <variable name="devCount" type="USINT">
      <connection refid="34">
        <position x="151" y="27" />
        <position x="150" y="27" />
        <position x="150" y="29" />
        <position x="108" y="29" />
        <position x="108" y="25" />
        <position x="108" y="25" />
      </connection>
    <comment>number of detected devices</comment>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="done" type="BOOL">
    <comment>block finished</comment>
    </variable>
    <variable name="busy" type="BOOL">
    <comment>block is still running</comment>
    </variable>
    <variable name="err" type="BOOL">
    <comment>block ended with error</comment>
    </variable>
    <variable name="errCode" type="USINT">
    <comment>error code</comment>
    </variable>
    <variable name="errTxt" type="STRING[80]">
    <comment>error report</comment>
    </variable>
    <variable name="DevMiBTypeCount" type="TDeviceMiBTypeCount">
    <comment>structure with count of each device type</comment>
    </variable>
  </outVariables>
</block>
<inVariable name="ADR(DeviceInfo)" type="" id="31">
  <position x="131" y="22" />
</inVariable>
<outVariable name="pass_done" type="BOOL" id="32" order="11">
  <position x="177" y="14" />
  <connection refid="35">
    <position x="178" y="15" />
    <position x="176" y="15" />
    <position x="176" y="15" />
    <position x="175" y="15" />
  </connection>
</outVariable>
<inVariable name="ADR(DeviceMiB)" type="" id="33">
  <position x="131" y="25" />
</inVariable>
<node id="34">
  <position x="108" y="25" />
  <connection refid="9" name="devCount">
    <position x="108" y="25" />
    <position x="74" y="25" />
    <position x="74" y="25" />
    <position x="61" y="25" />
  </connection>
</node>
<node id="35">
  <position x="175" y="15" />
  <connection refid="30" name="done">
    <position x="175" y="15" />
    <position x="174" y="15" />
    <position x="174" y="15" />
    <position x="173" y="15" />
  </connection>
</node>
<node id="36">
  <position x="129" y="35" />
  <connection refid="35">
    <position x="129" y="35" />
    <position x="175" y="35" />
    <position x="175" y="15" />
    <position x="175" y="15" />
  </connection>
</node>
<node id="37">
  <position x="86" y="35" />
  <connection refid="36">
    <position x="86" y="35" />
    <position x="104" y="35" />
    <position x="104" y="35" />
    <position x="129" y="35" />
  </connection>
</node>
<node id="38">
  <position x="107" y="6" />
  <connection refid="26">
    <position x="107" y="6" />
    <position x="33" y="6" />
    <position x="33" y="17" />
    <position x="33" y="17" />
  </connection>
</node>
<node id="39">
  <position x="105" y="7" />
  <connection refid="28">
    <position x="105" y="7" />
    <position x="35" y="7" />
    <position x="35" y="19" />
    <position x="35" y="19" />
  </connection>
</node>
<node id="40">
  <position x="103" y="8" />
  <connection refid="27">
    <position x="103" y="8" />
    <position x="37" y="8" />
    <position x="37" y="21" />
    <position x="37" y="21" />
  </connection>
</node>
<node id="41">
  <position x="84" y="52" />
  <connection refid="4" name="Q">
    <position x="84" y="52" />
    <position x="84" y="52" />
    <position x="84" y="43" />
    <position x="106" y="43" />
    <position x="106" y="50" />
    <position x="104" y="50" />
  </connection>
</node>
</fbd>
{/NOCODE}
//LVD
VAR
(* 599	*)	_Tmp_For_Back_Conn_4	:	BOOL;
(* 608	*)	_Tmp_For_Back_Conn_3	:	BOOL;
(* 644	*)	_Tmp_For_Back_Conn_2	:	BOOL;
(* 164	*)	_Tmp_For_Back_Conn_1	:	BOOL;
END_VAR

//TVD
VAR_TEMP
(* 422	*)	_Nod_Tmp_6	:	STRING[80];
(* 440	*)	_Nod_Tmp_5	:	UINT;
(* 431	*)	_Nod_Tmp_4	:	BOOL;
(* 606	*)	_Nod_Tmp_9	:	BOOL;
(* 642	*)	_Nod_Tmp_8	:	BOOL;
(* 579	*)	_Nod_Tmp_3	:	USINT;
(* 597	*)	_Nod_Tmp_2	:	BOOL;
(* 588	*)	_Nod_Tmp_1	:	BOOL;
END_VAR

//NC
//N000
(* 363	*)	LD 	IP_Address
(* 422	*)	ST	_Nod_Tmp_6
(* 366	*)	LD 	chanCode
(* 440	*)	ST	_Nod_Tmp_5
(* 369	*)	LD 	tcp
(* 431	*)	ST	_Nod_Tmp_4
(* 206	*)	CAL	smInit(enable:=smInit_enable, ip:=_Nod_Tmp_6, chanCode:=_Nod_Tmp_5, tcp:=_Nod_Tmp_4, DevInfoPtr:=ADR(DeviceInfo), DevInfoSize:=DEVICE_COUNT, InverterPtr:=ADR(Inverter), InverterCount:=INVERTER_COUNT, StringBoxPtr:=ADR(StringBox), StringBoxCount:=STRINGBOX_COUNT, BatteryPtr:=ADR(Battery), BatteryCount:=BATTERY_COUNT, MeterPtr:=ADR(Meter), MeterCount:=METER_COUNT)
(* 206	*)	LD 	smInit.DevTypeCount
(* 407	*)	ST 	DeviceTypeCount
//N002
(* 608	*)	LD	_Tmp_For_Back_Conn_3
//N000
(* 606	*)	ST	_Nod_Tmp_9
//N003
(* 644	*)	LD	_Tmp_For_Back_Conn_2
//N000
(* 642	*)	ST	_Nod_Tmp_8
(*  84	*)	CAL	timer_SR(S1:=_Nod_Tmp_9, R:=_Nod_Tmp_8)
(* 109	*)	CAL	timer(IN:=timer_SR.Q1, PT:=PERIOD_TIME)
(* 109	*)	LD 	timer.ET
(* 140	*)	ST 	timer_ET
(* 156	*)	LD 	smInit.done
(* 164	*)	OR 	_Tmp_For_Back_Conn_1
(* 181	*)	ST 	read_SR.S1
(* 181	*)	CAL	read_SR(R:=_Nod_Tmp_9)
(* 206	*)	LD 	smInit.devCount
(* 579	*)	ST	_Nod_Tmp_3
(*   8	*)	CAL	sm(enable:=read_SR.Q1, ip:=_Nod_Tmp_6, chanCode:=_Nod_Tmp_5, tcp:=_Nod_Tmp_4, DevInfoPtr:=ADR(DeviceInfo), devCount:=_Nod_Tmp_3)
//N001
(* 599	*)	LD	_Tmp_For_Back_Conn_4
//N000
(* 597	*)	ST	_Nod_Tmp_2
(* 449	*)	CAL	MiB_SR(S1:=sm.done, R:=_Nod_Tmp_2)
(* 474	*)	CAL	smMiB(enable:=MiB_SR.Q1, ip:=_Nod_Tmp_6, chanCode:=_Nod_Tmp_5, tcp:=_Nod_Tmp_4, DevInfoPtr:=ADR(DeviceInfo), DevMiBPtr:=ADR(DeviceMiB), devCount:=_Nod_Tmp_3)
(* 474	*)	LD 	smMiB.done
(* 588	*)	ST	_Nod_Tmp_1
(* 567	*)	ST 	pass_done
(* 588	*)	LD	_Nod_Tmp_1
//N001
(* 599	*)	ST	_Tmp_For_Back_Conn_4
//N000
(* 597	*)	LD	_Nod_Tmp_2
//N002
(* 608	*)	ST	_Tmp_For_Back_Conn_3
//N000
(* 109	*)	LD 	timer.Q
//N003
(* 644	*)	ST	_Tmp_For_Back_Conn_2
//N000
(* 642	*)	LD	_Nod_Tmp_8
//N004
(* 164	*)	ST	_Tmp_For_Back_Conn_1

END_PROGRAM
