PROGRAM prgMain
  VAR CONSTANT
    IP_Address      : STRING := '192.168.1.125:502';
    chanCode        : UINT   := ETH1_uni0;
    tcp             : BOOL   := true;

    InverterIdx : USINT := 1; (*logicke id zarizeni, pro ktere nastavujeme vykon*)
    INVERTER_COUNT  : USINT := 4;      (* maximalni pocet zarizeni typu Inverter *)
    DEVICE_COUNT    : USINT := INVERTER_COUNT;

    DEBUG_TIME: TIME := T#2s;

    PWCTRL_LOW: UINT := 60;
    PWCTRL_LOW_TIME: TIME := T#5s;//5m;
    PWCTRL_HIGH: UINT := 100;
    PWCTRL_HIGH_TIME: TIME := T#5s;//5m;
  END_VAR

  VAR_INPUT
  END_VAR
  VAR_OUTPUT
  END_VAR
  VAR
    smInit : fb_SMInit;
    DeviceInfo : ARRAY [1..DEVICE_COUNT]    OF TDeviceBlockInfo; (*Informace o blocich v jednotlivych zarizenich*)
    Inverter  : ARRAY [1 .. INVERTER_COUNT] OF TInverter;
    timer : TON;
    pwrctrl_val : UINT;
    state : USINT := 0;//: Automaton_State := AS_Init;
    after_state : USINT;
    next_state : USINT;
    next_step : BOOL;
    timer_ET : TIME;
    smPc : fb_SMPowerControl;
    setupVarsRead : setup_vars;
    setupVarsLow : setup_vars;
    setupVarsHigh : setup_vars;
    smFini : fb_SMFini;
    period : TIME;
    read : BOOL;
    debugTimer : TON;
    debug_ET : TIME;
  END_VAR
  VAR_TEMP
  END_VAR
{NOCODE}
<?xml version="1.0" encoding="windows-1250" ?>
<?xml-stylesheet type="text/xsl" href="pokus.xsl" version="1.1"?>
<fbd version="1.1">
<comment id="1" height="3" width="12">
  <position x="3" y="5" />
Schema comment
</comment>
<block name="TON" instance="timer" id="2" height="6" width="6" line="80" order="24">
  <position x="30" y="61" />
  <inVariables>
    <variable name="IN" type="BOOL">
      <connection refid="28" name="EQ">
        <position x="30" y="64" />
        <position x="28" y="64" />
        <position x="28" y="62" />
        <position x="27" y="62" />
      </connection>
    <comment>input</comment>
    </variable>
    <variable name="PT" type="TIME">
      <connection refid="59">
        <position x="30" y="66" />
        <position x="28" y="66" />
        <position x="28" y="67" />
        <position x="18" y="67" />
      </connection>
    <comment>preset</comment>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="Q" type="BOOL">
    <comment>output</comment>
    </variable>
    <variable name="ET" type="TIME">
    <comment>value</comment>
    </variable>
  </outVariables>
</block>
<outVariable name="timer_ET" type="TIME" id="3" order="25">
  <position x="53" y="70" />
  <connection refid="2" name="ET">
    <position x="54" y="71" />
    <position x="38" y="71" />
    <position x="38" y="66" />
    <position x="36" y="66" />
  </connection>
</outVariable>
<block name="fb_SMInit" instance="smInit" id="4" height="30" width="20" line="12" order="2">
  <position x="41" y="12" />
  <inVariables>
    <variable name="enable" type="BOOL">
      <connection refid="23" name="EQ">
        <position x="41" y="15" />
        <position x="40" y="15" />
        <position x="40" y="13" />
        <position x="28" y="13" />
      </connection>
    <comment>if enable=0, block is disabled, start with rising edge</comment>
    </variable>
    <variable name="ip" type="STRING[80]">
      <connection refid="19">
        <position x="41" y="17" />
        <position x="34" y="17" />
        <position x="34" y="17" />
        <position x="33" y="17" />
      </connection>
    <comment>SM2-MU gateway IP address</comment>
    </variable>
    <variable name="chanCode" type="UINT">
      <connection refid="21">
        <position x="41" y="19" />
        <position x="36" y="19" />
        <position x="36" y="19" />
        <position x="35" y="19" />
      </connection>
    <comment>communication channel number</comment>
    </variable>
    <variable name="tcp" type="BOOL">
      <connection refid="20">
        <position x="41" y="21" />
        <position x="38" y="21" />
        <position x="38" y="21" />
        <position x="37" y="21" />
      </connection>
    <comment>protocol type - TRUE = TCP, FALSE = UDP</comment>
    </variable>
    <variable name="DevInfoPtr" type="PTR_TO TDeviceBlockInfo">
      <connection refid="18">
        <position x="41" y="23" />
        <position x="21" y="23" />
        <position x="21" y="27" />
        <position x="14" y="27" />
      </connection>
    <comment>pointer to array start</comment>
    </variable>
    <variable name="DevInfoSize" type="USINT">
      <connection refid="9">
        <position x="41" y="25" />
        <position x="23" y="25" />
        <position x="23" y="30" />
        <position x="13" y="30" />
      </connection>
    <comment>max. number of devices (array size)</comment>
    </variable>
    <variable name="InverterPtr" type="PTR_TO TInverter">
      <connection refid="10">
        <position x="41" y="27" />
        <position x="25" y="27" />
        <position x="25" y="33" />
        <position x="12" y="33" />
      </connection>
    <comment>Pointer to array of Inverter structures</comment>
    </variable>
    <variable name="InverterCount" type="USINT">
      <connection refid="14">
        <position x="41" y="29" />
        <position x="27" y="29" />
        <position x="27" y="36" />
        <position x="15" y="36" />
      </connection>
    <comment>max. number of Inverters (array size)</comment>
    </variable>
    <variable name="StringBoxPtr" type="PTR_TO TStringBox">
      <connection refid="11">
        <position x="41" y="31" />
        <position x="29" y="31" />
        <position x="29" y="39" />
        <position x="3" y="39" />
      </connection>
    <comment>Pointer to array of StringBox structures</comment>
    </variable>
    <variable name="StringBoxCount" type="USINT">
      <connection refid="15">
        <position x="41" y="33" />
        <position x="31" y="33" />
        <position x="31" y="42" />
        <position x="3" y="42" />
      </connection>
    <comment>max. number of Inverters (array size)</comment>
    </variable>
    <variable name="BatteryPtr" type="PTR_TO TBattery">
      <connection refid="12">
        <position x="41" y="35" />
        <position x="33" y="35" />
        <position x="33" y="45" />
        <position x="3" y="45" />
      </connection>
    <comment>Pointer to array of Battery structures</comment>
    </variable>
    <variable name="BatteryCount" type="USINT">
      <connection refid="16">
        <position x="41" y="37" />
        <position x="35" y="37" />
        <position x="35" y="48" />
        <position x="3" y="48" />
      </connection>
    <comment>max. number of Batteries (array size)</comment>
    </variable>
    <variable name="MeterPtr" type="PTR_TO TMeter">
      <connection refid="13">
        <position x="41" y="39" />
        <position x="37" y="39" />
        <position x="37" y="51" />
        <position x="3" y="51" />
      </connection>
    <comment>Pointer to array of Meter structures</comment>
    </variable>
    <variable name="MeterCount" type="USINT">
      <connection refid="17">
        <position x="41" y="41" />
        <position x="39" y="41" />
        <position x="39" y="54" />
        <position x="3" y="54" />
      </connection>
    <comment>max. number of Meters (array size)</comment>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="done" type="BOOL">
    <comment>block finished</comment>
    </variable>
    <variable name="busy" type="BOOL">
    <comment>block is still running</comment>
    </variable>
    <variable name="err" type="BOOL">
    <comment>block ended with error</comment>
    </variable>
    <variable name="errCode" type="USINT">
    <comment>error code</comment>
    </variable>
    <variable name="errTxt" type="STRING[80]">
    <comment>error report</comment>
    </variable>
    <variable name="devCount" type="USINT">
    <comment>number of devices in the SM2-MU gateway</comment>
    </variable>
    <variable name="DevTypeCount" type="TDeviceTypeCount">
    <comment>structure with count of each device type</comment>
    </variable>
  </outVariables>
</block>
<inVariable name="0" type="" id="5">
  <position x="20" y="14" />
</inVariable>
<inVariable name="IP_Address" type="STRING" id="6">
  <position x="1" y="17" />
</inVariable>
<inVariable name="chanCode" type="UINT" id="7">
  <position x="1" y="20" />
</inVariable>
<inVariable name="tcp" type="BOOL" id="8">
  <position x="1" y="23" />
</inVariable>
<inVariable name="DEVICE_COUNT" type="USINT" id="9">
  <position x="1" y="29" />
</inVariable>
<inVariable name="ADR(Inverter)" type="" id="10">
  <position x="0" y="32" />
</inVariable>
<inVariable name="0" type="" id="11">
  <position x="1" y="38" />
</inVariable>
<inVariable name="0" type="" id="12">
  <position x="0" y="44" />
</inVariable>
<inVariable name="0" type="" id="13">
  <position x="0" y="50" />
</inVariable>
<inVariable name="INVERTER_COUNT" type="USINT" id="14">
  <position x="1" y="35" />
  <comment>
 maximalni pocet zarizeni typu Inverter   </comment>
</inVariable>
<inVariable name="0" type="" id="15">
  <position x="0" y="41" />
</inVariable>
<inVariable name="0" type="" id="16">
  <position x="0" y="47" />
</inVariable>
<inVariable name="0" type="" id="17">
  <position x="0" y="53" />
</inVariable>
<inVariable name="ADR(DeviceInfo)" type="" id="18">
  <position x="1" y="26" />
</inVariable>
<node id="19">
  <position x="33" y="17" />
  <connection refid="6">
    <position x="33" y="17" />
    <position x="17" y="17" />
    <position x="17" y="18" />
    <position x="10" y="18" />
  </connection>
</node>
<node id="20">
  <position x="37" y="21" />
  <connection refid="8">
    <position x="37" y="21" />
    <position x="19" y="21" />
    <position x="19" y="24" />
    <position x="5" y="24" />
  </connection>
</node>
<node id="21">
  <position x="35" y="19" />
  <connection refid="7">
    <position x="35" y="19" />
    <position x="17" y="19" />
    <position x="17" y="21" />
    <position x="9" y="21" />
  </connection>
</node>
<block name="MOVE" instance="" function="true" hiddenPins="true" operator="true" special="1" id="22" height="6" width="7" line="19" order="3">
  <position x="67" y="10" />
  <inVariables>
    <variable name="__EN" type="BOOL" eneno="true">
      <connection refid="4" name="done">
        <position x="67" y="13" />
        <position x="62" y="13" />
        <position x="62" y="15" />
        <position x="61" y="15" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="__ENO" type="BOOL" eneno="true">
    </variable>
  </outVariables>
  <inVariables>
    <variable name="IN1" type="ANY">
      <connection refid="24">
        <position x="67" y="15" />
        <position x="66" y="15" />
        <position x="66" y="15" />
        <position x="65" y="15" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="MOVE" type="ANY">
    </variable>
  </outVariables>
</block>
<block name="EQ" instance="" function="true" hiddenPins="true" operator="true" id="23" height="4" width="3" line="4" order="1">
  <position x="25" y="12" />
  <inVariables>
    <variable name="IN1" type="ANY">
      <connection refid="35">
        <position x="25" y="13" />
        <position x="17" y="13" />
        <position x="17" y="15" />
        <position x="5" y="15" />
      </connection>
    </variable>
    <variable name="IN2" type="ANY">
      <connection refid="5">
        <position x="25" y="15" />
        <position x="24" y="15" />
        <position x="24" y="15" />
        <position x="22" y="15" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="EQ" type="BOOL">
    <comment>Equality
  returns true if IN1 = IN2
</comment>
    </variable>
  </outVariables>
</block>
<inVariable name="2" type="" id="24">
  <position x="63" y="14" />
</inVariable>
<block name="EQ" instance="" function="true" hiddenPins="true" operator="true" id="25" height="4" width="3" line="24" order="5">
  <position x="98" y="12" />
  <inVariables>
    <variable name="IN1" type="ANY">
      <connection refid="36">
        <position x="98" y="13" />
        <position x="97" y="13" />
        <position x="97" y="13" />
        <position x="94" y="13" />
      </connection>
    </variable>
    <variable name="IN2" type="ANY">
      <connection refid="26">
        <position x="98" y="15" />
        <position x="95" y="15" />
        <position x="95" y="15" />
        <position x="92" y="15" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="EQ" type="BOOL">
    <comment>Equality
  returns true if IN1 = IN2
</comment>
    </variable>
  </outVariables>
</block>
<inVariable name="1" type="" id="26">
  <position x="90" y="14" />
</inVariable>
<block name="EQ" instance="" function="true" hiddenPins="true" operator="true" id="27" height="4" width="3" line="38" order="9">
  <position x="92" y="35" />
  <inVariables>
    <variable name="IN1" type="ANY">
      <connection refid="41">
        <position x="92" y="36" />
        <position x="91" y="36" />
        <position x="91" y="36" />
        <position x="87" y="36" />
      </connection>
    </variable>
    <variable name="IN2" type="ANY">
      <connection refid="31">
        <position x="92" y="38" />
        <position x="89" y="38" />
        <position x="89" y="38" />
        <position x="85" y="38" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="EQ" type="BOOL">
    <comment>Equality
  returns true if IN1 = IN2
</comment>
    </variable>
  </outVariables>
</block>
<block name="EQ" instance="" function="true" hiddenPins="true" operator="true" id="28" height="4" width="3" line="78" order="23">
  <position x="24" y="61" />
  <inVariables>
    <variable name="IN1" type="ANY">
      <connection refid="39">
        <position x="24" y="62" />
        <position x="23" y="62" />
        <position x="23" y="61" />
        <position x="16" y="61" />
      </connection>
    </variable>
    <variable name="IN2" type="ANY">
      <connection refid="33">
        <position x="24" y="64" />
        <position x="18" y="64" />
        <position x="18" y="64" />
        <position x="14" y="64" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="EQ" type="BOOL">
    <comment>Equality
  returns true if IN1 = IN2
</comment>
    </variable>
  </outVariables>
</block>
<block name="MOVE" instance="" function="true" hiddenPins="true" operator="true" special="1" id="29" height="6" width="7" line="33" order="7">
  <position x="133" y="12" />
  <inVariables>
    <variable name="__EN" type="BOOL" eneno="true">
      <connection refid="42" name="done">
        <position x="133" y="15" />
        <position x="126" y="15" />
        <position x="126" y="15" />
        <position x="119" y="15" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="__ENO" type="BOOL" eneno="true">
    </variable>
  </outVariables>
  <inVariables>
    <variable name="IN1" type="ANY">
      <connection refid="32">
        <position x="133" y="17" />
        <position x="132" y="17" />
        <position x="132" y="17" />
        <position x="130" y="17" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="MOVE" type="ANY">
    </variable>
  </outVariables>
</block>
<block name="MOVE" instance="" function="true" hiddenPins="true" operator="true" special="1" id="30" height="6" width="7" line="89" order="26">
  <position x="44" y="61" />
  <inVariables>
    <variable name="__EN" type="BOOL" eneno="true">
      <connection refid="2" name="Q">
        <position x="44" y="64" />
        <position x="38" y="64" />
        <position x="38" y="64" />
        <position x="36" y="64" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="__ENO" type="BOOL" eneno="true">
    </variable>
  </outVariables>
  <inVariables>
    <variable name="IN1" type="ANY">
      <connection refid="34">
        <position x="44" y="66" />
        <position x="43" y="66" />
        <position x="43" y="66" />
        <position x="42" y="66" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="MOVE" type="ANY">
    </variable>
  </outVariables>
</block>
<inVariable name="2" type="" id="31">
  <position x="83" y="37" />
</inVariable>
<inVariable name="after_state" type="USINT" id="32">
  <position x="122" y="16" />
</inVariable>
<inVariable name="6" type="" id="33">
  <position x="12" y="63" />
</inVariable>
<inVariable name="1" type="" id="34">
  <position x="40" y="65" />
</inVariable>
<inVariable name="state" type="USINT" id="35">
  <position x="1" y="14" />
  <comment>
: Automaton_State := AS_Init;  </comment>
</inVariable>
<inVariable name="state" type="USINT" id="36">
  <position x="90" y="12" />
  <comment>
: Automaton_State := AS_Init;  </comment>
</inVariable>
<outVariable name="next_state" type="USINT" id="37" order="8">
  <position x="141" y="16" />
  <connection refid="29" name="MOVE">
    <position x="142" y="17" />
    <position x="141" y="17" />
    <position x="141" y="17" />
    <position x="140" y="17" />
  </connection>
</outVariable>
<outVariable name="next_state" type="USINT" id="38" order="27">
  <position x="52" y="65" />
  <connection refid="30" name="MOVE">
    <position x="53" y="66" />
    <position x="52" y="66" />
    <position x="52" y="66" />
    <position x="51" y="66" />
  </connection>
</outVariable>
<inVariable name="state" type="USINT" id="39">
  <position x="12" y="60" />
  <comment>
: Automaton_State := AS_Init;  </comment>
</inVariable>
<outVariable name="next_state" type="USINT" id="40" order="4">
  <position x="75" y="14" />
  <connection refid="22" name="MOVE">
    <position x="76" y="15" />
    <position x="75" y="15" />
    <position x="75" y="15" />
    <position x="74" y="15" />
  </connection>
</outVariable>
<inVariable name="state" type="USINT" id="41">
  <position x="83" y="35" />
  <comment>
: Automaton_State := AS_Init;  </comment>
</inVariable>
<block name="fb_SMPowerControl" instance="smPc" id="42" height="18" width="15" line="26" order="6">
  <position x="104" y="12" />
  <inVariables>
    <variable name="enable" type="BOOL">
      <connection refid="25" name="EQ">
        <position x="104" y="15" />
        <position x="102" y="15" />
        <position x="102" y="13" />
        <position x="101" y="13" />
      </connection>
    <comment>if enable=0, block is disabled, start with rising edge</comment>
    </variable>
    <variable name="ip" type="STRING[80]">
      <connection refid="19">
        <position x="104" y="17" />
        <position x="89" y="17" />
        <position x="89" y="6" />
        <position x="33" y="6" />
        <position x="33" y="17" />
        <position x="33" y="17" />
      </connection>
    <comment>SM2-MU gateway IP address</comment>
    </variable>
    <variable name="chanCode" type="UINT">
      <connection refid="21">
        <position x="104" y="19" />
        <position x="88" y="19" />
        <position x="88" y="7" />
        <position x="35" y="7" />
        <position x="35" y="19" />
        <position x="35" y="19" />
      </connection>
    <comment>communication channel number</comment>
    </variable>
    <variable name="tcp" type="BOOL">
      <connection refid="104">
        <position x="104" y="21" />
        <position x="95" y="21" />
        <position x="95" y="21" />
        <position x="87" y="21" />
      </connection>
    <comment>protocol type - TRUE = TCP, FALSE = UDP</comment>
    </variable>
    <variable name="read" type="BOOL">
      <connection refid="70">
        <position x="104" y="23" />
        <position x="103" y="23" />
        <position x="103" y="23" />
        <position x="95" y="23" />
      </connection>
    <comment>TRUE - reading, FALSE - writting</comment>
    </variable>
    <variable name="active" type="BOOL">
      <connection refid="71">
        <position x="104" y="25" />
        <position x="103" y="25" />
        <position x="103" y="25" />
        <position x="95" y="25" />
      </connection>
    <comment>TRUE - active power, FALSE - reactive power</comment>
    </variable>
    <variable name="InverterPtr" type="PTR_TO TInverter">
      <connection refid="72">
        <position x="104" y="27" />
        <position x="98" y="27" />
        <position x="98" y="27" />
        <position x="96" y="27" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="done" type="BOOL">
    <comment>block finished</comment>
    </variable>
    <variable name="busy" type="BOOL">
    <comment>block is still running</comment>
    </variable>
    <variable name="err" type="BOOL">
    <comment>block ended with error</comment>
    </variable>
    <variable name="errCode" type="USINT">
    <comment>error code</comment>
    </variable>
    <variable name="errTxt" type="STRING[80]">
    <comment>error report</comment>
    </variable>
  </outVariables>
  <inOutVariables>
    <variable name="pwctrl" type="INT">
      <connection refid="73">
        <position x="104" y="29" />
        <position x="103" y="29" />
        <position x="103" y="30" />
        <position x="95" y="30" />
      </connection>
    <comment>set/read power value {CSY } nastavovana / prectena hodnota vykonu</comment>
    </variable>
  </inOutVariables>
</block>
<block name="setup_vars" instance="setupVarsRead" id="43" height="14" width="22" line="44" order="10">
  <position x="101" y="33" />
  <inVariables>
    <variable name="__EN" type="BOOL" eneno="true">
      <connection refid="27" name="EQ">
        <position x="101" y="36" />
        <position x="99" y="36" />
        <position x="99" y="36" />
        <position x="95" y="36" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="__ENO" type="BOOL" eneno="true">
    </variable>
  </outVariables>
  <inVariables>
    <variable name="state_new" type="USINT">
      <connection refid="60">
        <position x="101" y="38" />
        <position x="100" y="38" />
        <position x="100" y="38" />
        <position x="99" y="38" />
      </connection>
    </variable>
    <variable name="after_state_new" type="USINT">
      <connection refid="61">
        <position x="101" y="40" />
        <position x="100" y="40" />
        <position x="100" y="40" />
        <position x="99" y="40" />
      </connection>
    </variable>
    <variable name="read_new" type="BOOL">
      <connection refid="62">
        <position x="101" y="42" />
        <position x="100" y="42" />
        <position x="100" y="42" />
        <position x="99" y="42" />
      </connection>
    </variable>
    <variable name="pwrctrl_val_new" type="UINT">
      <connection refid="63">
        <position x="101" y="44" />
        <position x="100" y="44" />
        <position x="100" y="44" />
        <position x="98" y="44" />
      </connection>
    </variable>
    <variable name="period_new" type="TIME">
      <connection refid="64">
        <position x="101" y="46" />
        <position x="100" y="46" />
        <position x="100" y="46" />
        <position x="99" y="46" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="state" type="USINT">
    </variable>
    <variable name="after_state" type="USINT">
    </variable>
    <variable name="read" type="BOOL">
    </variable>
    <variable name="pwrctrl_val" type="UINT">
    </variable>
    <variable name="period" type="TIME">
    </variable>
  </outVariables>
</block>
<block name="setup_vars" instance="setupVarsLow" id="44" height="14" width="22" line="64" order="17">
  <position x="101" y="50" />
  <inVariables>
    <variable name="__EN" type="BOOL" eneno="true">
      <connection refid="50" name="EQ">
        <position x="101" y="53" />
        <position x="97" y="53" />
        <position x="97" y="53" />
        <position x="95" y="53" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="__ENO" type="BOOL" eneno="true">
    </variable>
  </outVariables>
  <inVariables>
    <variable name="state_new" type="USINT">
      <connection refid="74">
        <position x="101" y="55" />
        <position x="100" y="55" />
        <position x="100" y="55" />
        <position x="99" y="55" />
      </connection>
    </variable>
    <variable name="after_state_new" type="USINT">
      <connection refid="75">
        <position x="101" y="57" />
        <position x="100" y="57" />
        <position x="100" y="57" />
        <position x="99" y="57" />
      </connection>
    </variable>
    <variable name="read_new" type="BOOL">
      <connection refid="76">
        <position x="101" y="59" />
        <position x="100" y="59" />
        <position x="100" y="59" />
        <position x="98" y="59" />
      </connection>
    </variable>
    <variable name="pwrctrl_val_new" type="UINT">
      <connection refid="77">
        <position x="101" y="61" />
        <position x="100" y="61" />
        <position x="100" y="61" />
        <position x="98" y="61" />
      </connection>
    </variable>
    <variable name="period_new" type="TIME">
      <connection refid="78">
        <position x="101" y="63" />
        <position x="100" y="63" />
        <position x="100" y="63" />
        <position x="99" y="63" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="state" type="USINT">
    </variable>
    <variable name="after_state" type="USINT">
    </variable>
    <variable name="read" type="BOOL">
    </variable>
    <variable name="pwrctrl_val" type="UINT">
    </variable>
    <variable name="period" type="TIME">
    </variable>
  </outVariables>
</block>
<block name="setup_vars" instance="setupVarsHigh" id="45" height="14" width="22" line="100" order="29">
  <position x="101" y="67" />
  <inVariables>
    <variable name="__EN" type="BOOL" eneno="true">
      <connection refid="53" name="EQ">
        <position x="101" y="70" />
        <position x="97" y="70" />
        <position x="97" y="70" />
        <position x="95" y="70" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="__ENO" type="BOOL" eneno="true">
    </variable>
  </outVariables>
  <inVariables>
    <variable name="state_new" type="USINT">
      <connection refid="79">
        <position x="101" y="72" />
        <position x="100" y="72" />
        <position x="100" y="72" />
        <position x="99" y="72" />
      </connection>
    </variable>
    <variable name="after_state_new" type="USINT">
      <connection refid="80">
        <position x="101" y="74" />
        <position x="100" y="74" />
        <position x="100" y="74" />
        <position x="99" y="74" />
      </connection>
    </variable>
    <variable name="read_new" type="BOOL">
      <connection refid="81">
        <position x="101" y="76" />
        <position x="100" y="76" />
        <position x="100" y="76" />
        <position x="98" y="76" />
      </connection>
    </variable>
    <variable name="pwrctrl_val_new" type="UINT">
      <connection refid="82">
        <position x="101" y="78" />
        <position x="100" y="78" />
        <position x="100" y="78" />
        <position x="99" y="78" />
      </connection>
    </variable>
    <variable name="period_new" type="TIME">
      <connection refid="83">
        <position x="101" y="80" />
        <position x="100" y="80" />
        <position x="100" y="80" />
        <position x="98" y="80" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="state" type="USINT">
    </variable>
    <variable name="after_state" type="USINT">
    </variable>
    <variable name="read" type="BOOL">
    </variable>
    <variable name="pwrctrl_val" type="UINT">
    </variable>
    <variable name="period" type="TIME">
    </variable>
  </outVariables>
</block>
<block name="fb_SMFini" instance="smFini" id="46" height="6" width="11" line="129" order="40">
  <position x="106" y="84" />
  <inVariables>
    <variable name="__EN" type="BOOL" eneno="true">
      <connection refid="56" name="EQ">
        <position x="106" y="87" />
        <position x="103" y="87" />
        <position x="103" y="87" />
        <position x="95" y="87" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="__ENO" type="BOOL" eneno="true">
    </variable>
  </outVariables>
  <inVariables>
    <variable name="tcp" type="BOOL">
      <connection refid="104">
        <position x="106" y="89" />
        <position x="104" y="89" />
        <position x="104" y="94" />
        <position x="71" y="94" />
        <position x="71" y="21" />
        <position x="87" y="21" />
      </connection>
    <comment>protocol type</comment>
    </variable>
  </inVariables>
</block>
<block name="MOVE" instance="" function="true" hiddenPins="true" operator="true" special="1" id="47" height="6" width="7" line="131" order="41">
  <position x="134" y="84" />
  <inVariables>
    <variable name="__EN" type="BOOL" eneno="true">
      <connection refid="46" name="__ENO">
        <position x="134" y="87" />
        <position x="124" y="87" />
        <position x="124" y="87" />
        <position x="117" y="87" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="__ENO" type="BOOL" eneno="true">
    </variable>
  </outVariables>
  <inVariables>
    <variable name="IN1" type="ANY">
      <connection refid="48">
        <position x="134" y="89" />
        <position x="133" y="89" />
        <position x="133" y="89" />
        <position x="132" y="89" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="MOVE" type="ANY">
    </variable>
  </outVariables>
</block>
<inVariable name="6" type="" id="48">
  <position x="130" y="88" />
</inVariable>
<outVariable name="next_state" type="USINT" id="49" order="42">
  <position x="142" y="88" />
  <connection refid="47" name="MOVE">
    <position x="143" y="89" />
    <position x="142" y="89" />
    <position x="142" y="89" />
    <position x="141" y="89" />
  </connection>
</outVariable>
<block name="EQ" instance="" function="true" hiddenPins="true" operator="true" id="50" height="4" width="3" line="58" order="16">
  <position x="92" y="52" />
  <inVariables>
    <variable name="IN1" type="ANY">
      <connection refid="52">
        <position x="92" y="53" />
        <position x="91" y="53" />
        <position x="91" y="53" />
        <position x="87" y="53" />
      </connection>
    </variable>
    <variable name="IN2" type="ANY">
      <connection refid="51">
        <position x="92" y="55" />
        <position x="90" y="55" />
        <position x="90" y="55" />
        <position x="85" y="55" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="EQ" type="BOOL">
    <comment>Equality
  returns true if IN1 = IN2
</comment>
    </variable>
  </outVariables>
</block>
<inVariable name="3" type="" id="51">
  <position x="83" y="54" />
</inVariable>
<inVariable name="state" type="USINT" id="52">
  <position x="83" y="52" />
  <comment>
: Automaton_State := AS_Init;  </comment>
</inVariable>
<block name="EQ" instance="" function="true" hiddenPins="true" operator="true" id="53" height="4" width="3" line="94" order="28">
  <position x="92" y="69" />
  <inVariables>
    <variable name="IN1" type="ANY">
      <connection refid="55">
        <position x="92" y="70" />
        <position x="91" y="70" />
        <position x="91" y="70" />
        <position x="87" y="70" />
      </connection>
    </variable>
    <variable name="IN2" type="ANY">
      <connection refid="54">
        <position x="92" y="72" />
        <position x="91" y="72" />
        <position x="91" y="72" />
        <position x="85" y="72" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="EQ" type="BOOL">
    <comment>Equality
  returns true if IN1 = IN2
</comment>
    </variable>
  </outVariables>
</block>
<inVariable name="4" type="" id="54">
  <position x="83" y="71" />
</inVariable>
<inVariable name="state" type="USINT" id="55">
  <position x="83" y="69" />
  <comment>
: Automaton_State := AS_Init;  </comment>
</inVariable>
<block name="EQ" instance="" function="true" hiddenPins="true" operator="true" id="56" height="4" width="3" line="123" order="39">
  <position x="92" y="86" />
  <inVariables>
    <variable name="IN1" type="ANY">
      <connection refid="58">
        <position x="92" y="87" />
        <position x="91" y="87" />
        <position x="91" y="87" />
        <position x="87" y="87" />
      </connection>
    </variable>
    <variable name="IN2" type="ANY">
      <connection refid="57">
        <position x="92" y="89" />
        <position x="91" y="89" />
        <position x="91" y="89" />
        <position x="85" y="89" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="EQ" type="BOOL">
    <comment>Equality
  returns true if IN1 = IN2
</comment>
    </variable>
  </outVariables>
</block>
<inVariable name="5" type="" id="57">
  <position x="83" y="88" />
</inVariable>
<inVariable name="state" type="USINT" id="58">
  <position x="83" y="86" />
  <comment>
: Automaton_State := AS_Init;  </comment>
</inVariable>
<inVariable name="period" type="TIME" id="59">
  <position x="12" y="66" />
</inVariable>
<inVariable name="1" type="" id="60">
  <position x="97" y="37" />
</inVariable>
<inVariable name="3" type="" id="61">
  <position x="97" y="39" />
</inVariable>
<inVariable name="true" type="BOOL" id="62">
  <position x="95" y="41" />
</inVariable>
<inVariable name="PWCTRL_LOW" type="UINT" id="63">
  <position x="87" y="43" />
</inVariable>
<inVariable name="T#0s" type="TIME" id="64">
  <position x="94" y="45" />
</inVariable>
<outVariable name="next_state" type="USINT" id="65" order="11">
  <position x="125" y="37" />
  <connection refid="43" name="state">
    <position x="126" y="38" />
    <position x="124" y="38" />
    <position x="124" y="38" />
    <position x="123" y="38" />
  </connection>
</outVariable>
<outVariable name="after_state" type="USINT" id="66" order="12">
  <position x="125" y="39" />
  <connection refid="43" name="after_state">
    <position x="126" y="40" />
    <position x="124" y="40" />
    <position x="124" y="40" />
    <position x="123" y="40" />
  </connection>
</outVariable>
<outVariable name="read" type="BOOL" id="67" order="13">
  <position x="125" y="41" />
  <connection refid="43" name="read">
    <position x="126" y="42" />
    <position x="124" y="42" />
    <position x="124" y="42" />
    <position x="123" y="42" />
  </connection>
</outVariable>
<outVariable name="pwrctrl_val" type="UINT" id="68" order="14">
  <position x="125" y="43" />
  <connection refid="43" name="pwrctrl_val">
    <position x="126" y="44" />
    <position x="124" y="44" />
    <position x="124" y="44" />
    <position x="123" y="44" />
  </connection>
</outVariable>
<outVariable name="period" type="TIME" id="69" order="22">
  <position x="125" y="62" />
  <connection refid="44" name="period">
    <position x="126" y="63" />
    <position x="125" y="63" />
    <position x="125" y="63" />
    <position x="123" y="63" />
  </connection>
</outVariable>
<inVariable name="read" type="BOOL" id="70">
  <position x="91" y="22" />
</inVariable>
<inVariable name="true" type="BOOL" id="71">
  <position x="91" y="24" />
</inVariable>
<inVariable name="ADR(Inverter[InverterIdx])" type="" id="72">
  <position x="77" y="26" />
</inVariable>
<inVariable name="pwrctrl_val" type="UINT" id="73">
  <position x="86" y="29" />
</inVariable>
<inVariable name="5" type="" id="74">
  <position x="97" y="54" />
</inVariable>
<inVariable name="4" type="" id="75">
  <position x="97" y="56" />
</inVariable>
<inVariable name="false" type="BOOL" id="76">
  <position x="94" y="58" />
</inVariable>
<inVariable name="PWCTRL_LOW" type="UINT" id="77">
  <position x="87" y="60" />
</inVariable>
<inVariable name="PWCTRL_HIGH_TIME" type="TIME" id="78">
  <position x="83" y="62" />
  <comment>
5m;  </comment>
</inVariable>
<inVariable name="5" type="" id="79">
  <position x="97" y="71" />
</inVariable>
<inVariable name="3" type="" id="80">
  <position x="97" y="73" />
</inVariable>
<inVariable name="false" type="BOOL" id="81">
  <position x="94" y="75" />
</inVariable>
<inVariable name="PWCTRL_HIGH" type="UINT" id="82">
  <position x="87" y="77" />
</inVariable>
<inVariable name="PWCTRL_LOW_TIME" type="TIME" id="83">
  <position x="83" y="79" />
  <comment>
5m;  </comment>
</inVariable>
<outVariable name="next_state" type="USINT" id="84" order="30">
  <position x="125" y="71" />
  <connection refid="45" name="state">
    <position x="126" y="72" />
    <position x="124" y="72" />
    <position x="124" y="72" />
    <position x="123" y="72" />
  </connection>
</outVariable>
<outVariable name="after_state" type="USINT" id="85" order="31">
  <position x="125" y="73" />
  <connection refid="45" name="after_state">
    <position x="126" y="74" />
    <position x="124" y="74" />
    <position x="124" y="74" />
    <position x="123" y="74" />
  </connection>
</outVariable>
<outVariable name="read" type="BOOL" id="86" order="32">
  <position x="125" y="75" />
  <connection refid="45" name="read">
    <position x="126" y="76" />
    <position x="124" y="76" />
    <position x="124" y="76" />
    <position x="123" y="76" />
  </connection>
</outVariable>
<outVariable name="pwrctrl_val" type="UINT" id="87" order="33">
  <position x="125" y="77" />
  <connection refid="45" name="pwrctrl_val">
    <position x="126" y="78" />
    <position x="124" y="78" />
    <position x="124" y="78" />
    <position x="123" y="78" />
  </connection>
</outVariable>
<outVariable name="period" type="TIME" id="88" order="34">
  <position x="125" y="79" />
  <connection refid="45" name="period">
    <position x="126" y="80" />
    <position x="125" y="80" />
    <position x="125" y="80" />
    <position x="123" y="80" />
  </connection>
</outVariable>
<outVariable name="next_state" type="USINT" id="89" order="18">
  <position x="125" y="54" />
  <connection refid="44" name="state">
    <position x="126" y="55" />
    <position x="124" y="55" />
    <position x="124" y="55" />
    <position x="123" y="55" />
  </connection>
</outVariable>
<outVariable name="after_state" type="USINT" id="90" order="19">
  <position x="125" y="56" />
  <connection refid="44" name="after_state">
    <position x="126" y="57" />
    <position x="124" y="57" />
    <position x="124" y="57" />
    <position x="123" y="57" />
  </connection>
</outVariable>
<outVariable name="read" type="BOOL" id="91" order="20">
  <position x="125" y="58" />
  <connection refid="44" name="read">
    <position x="126" y="59" />
    <position x="125" y="59" />
    <position x="125" y="59" />
    <position x="123" y="59" />
  </connection>
</outVariable>
<outVariable name="pwrctrl_val" type="UINT" id="92" order="21">
  <position x="125" y="60" />
  <connection refid="44" name="pwrctrl_val">
    <position x="126" y="61" />
    <position x="124" y="61" />
    <position x="124" y="61" />
    <position x="123" y="61" />
  </connection>
</outVariable>
<outVariable name="period" type="TIME" id="93" order="15">
  <position x="125" y="45" />
  <connection refid="43" name="period">
    <position x="126" y="46" />
    <position x="124" y="46" />
    <position x="124" y="46" />
    <position x="123" y="46" />
  </connection>
</outVariable>
<block name="TON" instance="debugTimer" id="94" height="6" width="6" line="116" order="36">
  <position x="30" y="75" />
  <inVariables>
    <variable name="IN" type="BOOL">
      <connection refid="105" name="NE">
        <position x="30" y="78" />
        <position x="28" y="78" />
        <position x="28" y="76" />
        <position x="27" y="76" />
      </connection>
    <comment>input</comment>
    </variable>
    <variable name="PT" type="TIME">
      <connection refid="98">
        <position x="30" y="80" />
        <position x="28" y="80" />
        <position x="28" y="81" />
        <position x="22" y="81" />
      </connection>
    <comment>preset</comment>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="Q" type="BOOL">
    <comment>output</comment>
    </variable>
    <variable name="ET" type="TIME">
    <comment>value</comment>
    </variable>
  </outVariables>
</block>
<outVariable name="debug_ET" type="TIME" id="95" order="38">
  <position x="52" y="82" />
  <connection refid="94" name="ET">
    <position x="53" y="83" />
    <position x="38" y="83" />
    <position x="38" y="80" />
    <position x="36" y="80" />
  </connection>
</outVariable>
<inVariable name="state" type="USINT" id="96">
  <position x="12" y="77" />
  <comment>
: Automaton_State := AS_Init;  </comment>
</inVariable>
<inVariable name="next_state" type="USINT" id="97">
  <position x="12" y="74" />
</inVariable>
<inVariable name="DEBUG_TIME" type="TIME" id="98">
  <position x="12" y="80" />
</inVariable>
<outVariable name="next_step" type="BOOL" id="99" order="37">
  <position x="52" y="77" />
  <connection refid="94" name="Q">
    <position x="53" y="78" />
    <position x="39" y="78" />
    <position x="39" y="78" />
    <position x="36" y="78" />
  </connection>
</outVariable>
<block name="MOVE" instance="" function="true" hiddenPins="true" operator="true" special="1" id="100" height="6" width="7" line="141" order="43">
  <position x="30" y="88" />
  <inVariables>
    <variable name="__EN" type="BOOL" eneno="true">
      <connection refid="101">
        <position x="30" y="91" />
        <position x="28" y="91" />
        <position x="28" y="89" />
        <position x="20" y="89" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="__ENO" type="BOOL" eneno="true">
    </variable>
  </outVariables>
  <inVariables>
    <variable name="IN1" type="ANY">
      <connection refid="102">
        <position x="30" y="93" />
        <position x="26" y="93" />
        <position x="26" y="93" />
        <position x="20" y="93" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="MOVE" type="ANY">
    </variable>
  </outVariables>
</block>
<inVariable name="next_step" type="BOOL" id="101">
  <position x="12" y="88" />
</inVariable>
<inVariable name="next_state" type="USINT" id="102">
  <position x="12" y="92" />
</inVariable>
<outVariable name="state" type="USINT" id="103" order="44">
  <position x="55" y="92" />
  <comment>
: Automaton_State := AS_Init;  </comment>
  <connection refid="100" name="MOVE">
    <position x="56" y="93" />
    <position x="39" y="93" />
    <position x="39" y="93" />
    <position x="37" y="93" />
  </connection>
</outVariable>
<node id="104">
  <position x="87" y="21" />
  <connection refid="20">
    <position x="87" y="21" />
    <position x="87" y="21" />
    <position x="87" y="8" />
    <position x="37" y="8" />
    <position x="37" y="21" />
    <position x="37" y="21" />
  </connection>
</node>
<block name="NE" instance="" function="true" hiddenPins="true" operator="true" id="105" height="4" width="3" line="114" order="35">
  <position x="24" y="75" />
  <inVariables>
    <variable name="IN1" type="ANY">
      <connection refid="97">
        <position x="24" y="76" />
        <position x="23" y="76" />
        <position x="23" y="75" />
        <position x="20" y="75" />
      </connection>
    </variable>
    <variable name="IN2" type="ANY">
      <connection refid="96">
        <position x="24" y="78" />
        <position x="20" y="78" />
        <position x="20" y="78" />
        <position x="16" y="78" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="NE" type="BOOL">
    <comment>Inequality
  returns true if IN1 &lt;&gt; IN2
</comment>
    </variable>
  </outVariables>
</block>
</fbd>
{/NOCODE}
//LVD
VAR
END_VAR

//TVD
VAR_TEMP
(* 246	*)	_Nod_Tmp_15	:	STRING[80];
(* 264	*)	_Nod_Tmp_14	:	UINT;
(* 255	*)	_Nod_Tmp_11	:	BOOL;
END_VAR

//NC
//N019
(* 308	*)	LD 	state
(* 316	*)	EQ 	0
(*  48	*)	ST 	smInit.enable
(* 205	*)	LD 	IP_Address
(* 246	*)	ST	_Nod_Tmp_15
(* 208	*)	LD 	chanCode
(* 264	*)	ST	_Nod_Tmp_14
(* 211	*)	LD 	tcp
(* 255	*)	ST	_Nod_Tmp_11
(*  48	*)	CAL	smInit(ip:=_Nod_Tmp_15, chanCode:=_Nod_Tmp_14, tcp:=_Nod_Tmp_11, DevInfoPtr:=ADR(DeviceInfo), DevInfoSize:=DEVICE_COUNT, InverterPtr:=ADR(Inverter), InverterCount:=INVERTER_COUNT, StringBoxPtr:=0, StringBoxCount:=0, BatteryPtr:=0, BatteryCount:=0, MeterPtr:=0, MeterCount:=0)
(*  48	*)	LD 	smInit.done
//N002
{CREATE_TEMP=__TmpEn_0}
(* 277	*)	ST	__TmpEn_0
(* 277	*)	LD	__TmpEn_0
(* 277	*)	JMPCN __PouSkip_0_1
(* 291	*)	LD 	2
(* 529	*)	ST 	next_state
			__PouSkip_0_1:
//N019
(* 339	*)	LD 	state
(* 347	*)	EQ 	1
(* 543	*)	ST 	smPc.enable
(* 543	*)	CAL	smPc(ip:=_Nod_Tmp_15, chanCode:=_Nod_Tmp_14, tcp:=_Nod_Tmp_11, read:=read, active:=true, InverterPtr:=ADR(Inverter[InverterIdx]), pwctrl:=void(pwrctrl_val))
(* 543	*)	LD 	smPc.done
//N003
{CREATE_TEMP=__TmpEn_1}
(* 426	*)	ST	__TmpEn_1
(* 426	*)	LD	__TmpEn_1
(* 426	*)	JMPCN __PouSkip_1_2
(* 440	*)	LD 	after_state
(* 506	*)	ST 	next_state
			__PouSkip_1_2:
//N006
(* 370	*)	LD 	state
(* 378	*)	EQ 	2
//N007
{CREATE_TEMP=__TmpEn_2}
(* 646	*)	ST	__TmpEn_2
(* 646	*)	LD	__TmpEn_2
(* 646	*)	JMPCN __PouSkip_2_3
(* 642	*)	CAL	setupVarsRead(state_new:=1, after_state_new:=3, read_new:=true, pwrctrl_val_new:=PWCTRL_LOW, period_new:=T#0s)
(* 642	*)	LD 	setupVarsRead.state
(*1054	*)	ST 	next_state
(* 642	*)	LD 	setupVarsRead.after_state
(*1063	*)	ST 	after_state
(* 642	*)	LD 	setupVarsRead.read
(*1072	*)	ST 	read
(* 642	*)	LD 	setupVarsRead.pwrctrl_val
(*1081	*)	ST 	pwrctrl_val
(* 642	*)	LD 	setupVarsRead.period
(*1226	*)	ST 	period
			__PouSkip_2_3:
//N009
(* 932	*)	LD 	state
(* 940	*)	EQ 	3
//N010
{CREATE_TEMP=__TmpEn_3}
(* 717	*)	ST	__TmpEn_3
(* 717	*)	LD	__TmpEn_3
(* 717	*)	JMPCN __PouSkip_3_4
(* 713	*)	CAL	setupVarsLow(state_new:=5, after_state_new:=4, read_new:=false, pwrctrl_val_new:=PWCTRL_LOW, period_new:=PWCTRL_HIGH_TIME)
(* 713	*)	LD 	setupVarsLow.state
(*1190	*)	ST 	next_state
(* 713	*)	LD 	setupVarsLow.after_state
(*1199	*)	ST 	after_state
(* 713	*)	LD 	setupVarsLow.read
(*1208	*)	ST 	read
(* 713	*)	LD 	setupVarsLow.pwrctrl_val
(*1217	*)	ST 	pwrctrl_val
(* 713	*)	LD 	setupVarsLow.period
(*1090	*)	ST 	period
			__PouSkip_3_4:
//N011
(* 398	*)	LD 	state
(* 406	*)	EQ 	6
(*   8	*)	ST 	timer.IN
(*   8	*)	CAL	timer(PT:=period)
(*   8	*)	LD 	timer.ET
(*  39	*)	ST 	timer_ET
(*   8	*)	LD 	timer.Q
//N012
{CREATE_TEMP=__TmpEn_4}
(* 457	*)	ST	__TmpEn_4
(* 457	*)	LD	__TmpEn_4
(* 457	*)	JMPCN __PouSkip_4_5
(* 471	*)	LD 	1
(* 515	*)	ST 	next_state
			__PouSkip_4_5:
//N014
(* 968	*)	LD 	state
(* 976	*)	EQ 	4
//N015
{CREATE_TEMP=__TmpEn_5}
(* 788	*)	ST	__TmpEn_5
(* 788	*)	LD	__TmpEn_5
(* 788	*)	JMPCN __PouSkip_5_6
(* 784	*)	CAL	setupVarsHigh(state_new:=5, after_state_new:=3, read_new:=false, pwrctrl_val_new:=PWCTRL_HIGH, period_new:=PWCTRL_LOW_TIME)
(* 784	*)	LD 	setupVarsHigh.state
(*1145	*)	ST 	next_state
(* 784	*)	LD 	setupVarsHigh.after_state
(*1154	*)	ST 	after_state
(* 784	*)	LD 	setupVarsHigh.read
(*1163	*)	ST 	read
(* 784	*)	LD 	setupVarsHigh.pwrctrl_val
(*1172	*)	ST 	pwrctrl_val
(* 784	*)	LD 	setupVarsHigh.period
(*1181	*)	ST 	period
			__PouSkip_5_6:
//N016
(*1358	*)	LD 	next_state
(*1366	*)	NE 	state
(*1235	*)	ST 	debugTimer.IN
(*1235	*)	CAL	debugTimer(PT:=DEBUG_TIME)
(*1235	*)	LD 	debugTimer.Q
(*1286	*)	ST 	next_step
(*1235	*)	LD 	debugTimer.ET
(*1266	*)	ST 	debug_ET
//N018
(*1004	*)	LD 	state
(*1012	*)	EQ 	5
//N019
{CREATE_TEMP=__TmpEn_6}
(* 859	*)	ST	__TmpEn_6
(* 859	*)	LD	__TmpEn_6
(* 859	*)	JMPCN __PouSkip_6_7
(* 855	*)	CAL	smFini(tcp:=_Nod_Tmp_11)
//N020
(* 903	*)	LD 	6
(* 919	*)	ST 	next_state
			__PouSkip_6_7:
//N021
(*1326	*)	LD 	next_step
//N022
{CREATE_TEMP=__TmpEn_7}
(*1299	*)	ST	__TmpEn_7
(*1299	*)	LD	__TmpEn_7
(*1299	*)	JMPCN __PouSkip_7_8
(*1313	*)	LD 	next_state
(*1332	*)	ST 	state
			__PouSkip_7_8:

END_PROGRAM
